package nc.ui.cm.fetchdata.action;

package ..deTemp.1729931542941;

import java.awt.Container;
import java.awt.event.ActionEvent;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.itf.cm.fetchdata.IPullDataMaintainService;
import nc.itf.cm.fetchdata.IPullDataQueryService;
import nc.pubitf.initgroup.InitGroupQuery;
import nc.ui.cm.fetchdata.util.PullDataUtil;
import nc.ui.cm.fetchdata.view.ListFetchDataMainPnl;
import nc.ui.cm.pub.business.util.MMActionProgressor;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.uif2.NCAction;
import nc.ui.uif2.ShowStatusBarMsgUtil;
import nc.util.mmf.framework.base.MMArrayUtil;
import nc.util.mmf.framework.base.MMValueCheck;
import nc.vo.cm.fetchdata.cmconst.FetchDataLangConst;
import nc.vo.cm.fetchdata.entity.FetchParamVO;
import nc.vo.cm.fetchdata.entity.PullDataStateVO;
import nc.vo.cm.inprocost.entity.CMMLangConstBD0102;
import nc.vo.pub.BusinessException;

public class FetchDataAction extends NCAction {
  private static final long serialVersionUID = -7796364072744108436L;
  
  private IPullDataQueryService pullDataQueryService = null;
  
  private ListFetchDataMainPnl listFetchDataMainPnl;
  
  public FetchDataAction() {
    setBtnName(FetchDataLangConst.getBT_FETCHDATA());
  }
  
  public void doAction(ActionEvent e) throws Exception {
    String name = NCLangRes.getInstance().getStrByID("3830002_0", "03830002-0398");
    MMActionProgressor handler = new MMActionProgressor(this, "fetchData4SelectVO");
    handler.process(name);
  }
  
  public static boolean isCMEnabled(String code) throws BusinessException {
    return InitGroupQuery.isEnabled(InvocationInfoProxy.getInstance().getGroupId(), code);
  }
  
  public void fetchData4SelectVO() throws BusinessException {
    PullDataStateVO[] pullDataStateVOs = getFetchDataMainSelectVO();
    if (MMValueCheck.isEmpty(this.listFetchDataMainPnl.getAccountPeriod().getValueObj())) {
      MessageDialog.showErrorDlg((Container)getListFetchDataMainPnl(), CMMLangConstBD0102.GET_HINT_TITLE(), FetchDataLangConst.getUNSELECT_ACCOUNTPERIOD());
      return;
    } 
    if (MMArrayUtil.isEmpty((Object[])pullDataStateVOs)) {
      MessageDialog.showWarningDlg((Container)this.listFetchDataMainPnl, FetchDataLangConst.getWARN(), FetchDataLangConst.getWARN_SELECTNOROW());
      return;
    } 
    FetchParamVO paramvo = this.listFetchDataMainPnl.getParamVO(pullDataStateVOs);
    PullDataUtil.moduleEnable(paramvo);
    paramvo.setPullDataStateVOArr(pullDataStateVOs);
    if (!paramvo.isFetchBefore()) {
      PullDataStateVO[] allVO = getFetchDataMainAllVO();
      FetchParamVO allParamvo = this.listFetchDataMainPnl.getParamVO(allVO);
      paramvo.setAllFetchParamVo(allParamvo);
      PullDataUtil.setFetchedStatusTOallVO(allVO, pullDataStateVOs);
      allParamvo.setPullDataStateVOArr(allVO);
    } 
    boolean isRefresh = false;
    isRefresh = fetchdata(pullDataStateVOs, paramvo);
    if (isRefresh)
      getListFetchDataMainPnl().refreshDates(); 
  }
  
  private boolean fetchdata(PullDataStateVO[] pullDataStateVOs, FetchParamVO paramvo) throws BusinessException {
    boolean isCoverData = false;
    boolean isDeleteStatusInfo = false;
    if (isFethed(pullDataStateVOs)) {
      if (MessageDialog.showOkCancelDlg((Container)getListFetchDataMainPnl(), FetchDataLangConst.getWARN(), FetchDataLangConst.getERR_COVERFETCHDATD()) != 1)
        return false; 
      isDeleteStatusInfo = true;
      isCoverData = true;
    } 
    boolean isHasError = ((IPullDataMaintainService)NCLocator.getInstance().lookup(IPullDataMaintainService.class)).fetchData(paramvo, isCoverData, isDeleteStatusInfo);
    if (isHasError) {
      MessageDialog.showHintDlg((Container)getListFetchDataMainPnl(), FetchDataLangConst.getWARN(), FetchDataLangConst.getWARN_ERRORSINFOOFCHECK());
      return false;
    } 
    ShowStatusBarMsgUtil.showStatusBarMsg(FetchDataLangConst.getFETCH_FINISH(), getListFetchDataMainPnl().getModel().getContext());
    return true;
  }
  
  public Integer[] queryVoFromPullStatusInfo(PullDataStateVO paramvo) throws BusinessException {
    return getPullDataQueryService().queryVoFromPullStatusInfo(paramvo);
  }
  
  private boolean isFethed(PullDataStateVO[] paramvos) throws BusinessException {
    for (PullDataStateVO paramvo : paramvos) {
      if (paramvo.getBfetched().booleanValue())
        return true; 
    } 
    return false;
  }
  
  private PullDataStateVO[] getFetchDataMainSelectVO() {
    return (PullDataStateVO[])this.listFetchDataMainPnl.getBillListView().getBillListPanel().getHeadBillModel().getBodySelectedVOs(PullDataStateVO.class.getName());
  }
  
  private PullDataStateVO[] getFetchDataMainAllVO() {
    return (PullDataStateVO[])this.listFetchDataMainPnl.getBillListView().getBillListPanel().getHeadBillModel().getBodyValueVOs(PullDataStateVO.class.getName());
  }
  
  private IPullDataQueryService getPullDataQueryService() {
    if (this.pullDataQueryService == null)
      this.pullDataQueryService = (IPullDataQueryService)NCLocator.getInstance().lookup(IPullDataQueryService.class); 
    return this.pullDataQueryService;
  }
  
  public ListFetchDataMainPnl getListFetchDataMainPnl() {
    return this.listFetchDataMainPnl;
  }
  
  public void setListFetchDataMainPnl(ListFetchDataMainPnl listFetchDataMainPnl) {
    this.listFetchDataMainPnl = listFetchDataMainPnl;
  }
  
  public Integer getPullDataType() {
    return this.listFetchDataMainPnl.getPullDataType();
  }
}
